SuperStrict


Type TKey
	
	Field KeyCode:Int		'Ascii Code der Taste
	Field CharNr:Int		'Nummer des Frames im "Tileset"
	Field ToDestroy:Int		'Ob die Taste zerstrt (also gedrckt werden soll)
	Field Color:Int			'Grn oder rot
	Field X:Float
	Field Y:Float
	
	Field Del:Int			'Ob das Objekt weg muss
	
	Global Speed:Float
	Const SpeedIncrease:Float = 0.33
	Global SpeedIncreased:Int = 0
	
	Const COLOR_GREEN:Int = 0
	Const COLOR_RED:Int = 1
	
	Method Init( Char:String, ToDestroy_:Int, Color_:Int )
		
		Local AsciiCode:Int = Asc( Char )
		
		Self.CharNr = AsciiCode - Asc( "A" )
		Self.KeyCode = Self.CharNr + KEY_A
		
		'Print Char
		'Print Self.CharNr
		'Print Self.KeyCode
		
		Self.X = Rand( 0, 416 )
		Self.Y = -16
		
		Self.ToDestroy = ToDestroy_
		Self.Color = Color_
		
	End Method
	
	Method Update()
		
		Self.Y :+ TKey.Speed
		
		If KeyHit( Self.KeyCode ) Then
			If Self.ToDestroy = True Then
				Self.Del = True
				Counter :+ 1
			Else
				Lifes :- 1
				Local Key:TKey
				For Key = EachIn KeyList
					If Key.KeyCode = Self.KeyCode Then Key.Del = True
				Next
			End If
		End If
		
		If Self.Y >=516 Then
			If Self.ToDestroy = True Then
				Lifes :- 1
			Else
				Counter :+ 1
			End If
			Self.Del = True
		End If
		
	End Method
	
	Method Render()
		
		DrawImage Image_Colors, Self.X, Self.Y, Self.Color
		DrawImage Image_Keys, Self.X, Self.Y, Self.CharNr
		
	End Method
	
End Type


Type TParticle
	Field Image:TImage
	Field X:Float
	Field Y:Float
	Field V_X:Float
	Field V_Y:Float
	Field A_X:Float
	Field A_Y:Float
	Field R:Int
	Field V_R:Int
	Field A:Float
	Field V_A:Float
	Field Del:Int
	
	Method Init( X_:Int, Y_:Int, S:Int, I:Int )
		Local GX:Int = I Mod ( 32 / S )
		Local GY:Int = I / ( 32 / S )
		Self.Image = CreateImage( S, S )
		GrabImage( Self.Image, X_+GX*S, Y_+GY*S )
		SetImageHandle( Self.Image, S/2, S/2 )
		Self.X=X_+GX*S+S/2
		Self.Y=Y_+GY*S+S/2
		Self.V_X=((GX<((32/S)/2))*2-1)*Rand(1,3)
		Self.V_Y=Rand(-2,-10)
		Self.A_X=Self.V_X/Abs(Self.V_X)*(-.03)
		Self.A_Y=0.7
		Self.R=0
		Self.V_R=Rand(3,40)
		Self.A=1
		Self.V_A=-0.008
	End Method
	
	Method Update()
		Self.X :+ Self. V_X
		Self.Y :+ Self. V_Y
		Self.V_X :+ Self.A_X
		Self.V_Y :+ Self.A_Y
		Self.R :+ Self.V_R
		Self.A :+ Self.V_A
		If Self.A<=0 Then Self.Del=True
		If Self.Y >= 516 Then Self.V_Y = Self.V_Y*(-1)*.5
	End Method
	
	Method Render()
		SetRotation Self.R
		SetAlpha Self.A
		DrawImage Self.Image, Self.X, Self.Y
		SetAlpha 1
		SetRotation 0
	End Method
End Type



Global Image_Keys:TImage = LoadAnimImage( "gfx\keys.png", 32, 32, 0, 26 )
Global Image_Colors:TImage = LoadAnimImage( "gfx\colors.png", 32, 32, 0, 2 )
Global Image_Background:TImage = LoadImage( "gfx\bg.png" )
Global Image_Heart:TImage = LoadImage( "gfx\heart.png" )
Global Image_Status:TImage

Global BGColor_R:Int=200, BGColor_G:Int=200, BGColor_B:Int=170
Global BGColor_RM:Int, BGColor_GM:Int,  BGColor_BM:Int

Global Lifes:Int
Global Counter:Int
Global Highscores:Int[4]

Global KeyList:TList
Global ParticleList:TList

Global Timer:TTimer = CreateTimer( 60 )

Global Terminate:Int = False

Global CreationCounter:Float
Global CreationInterval:Float
Const CreationIntervalDecrease:Float = 8

Global KeyStack:String[]
Global Words:String[][3]
Global CurrentWord:String

Global GameMode:Int			'0=Men, 1=Normal, 2=Words
Global Difficulty:Int		'0=Men, 1=Leicht, 2=Normal, 3=Schwierig
Global MenuChoice:Int		'1=Normal, 2=Words, bzw 1=Leicht, 2=Normal, 3=Schwierig
Global Paused:Int

Global FasterTextTime:Int

Global ShowParticles:Int = true






AppTitle = "Keys On Fire"
Graphics 448, 580, 0
InitProgram()
SetBlend( ALPHABLEND )



While Not( Terminate = True )
	
	Select GameMode
		Case 0		'menu
			Render()
			Menu()
		Case 1		'normaler modus
			Update()
			Render()
		Case 2
			If Difficulty = 0 Then		'menu
				Render()
				Menu()
			Else						'word-modus
				Update()
				Render()
			End If
	End Select
	
	If KeyHit( KEY_ESCAPE ) Then GameOver()
	If ( GameMode = 0 Or Paused = 1 ) And KeyHit( KEY_P ) = True Then ShowParticles = Not( ShowParticles )
	FlushKeys()
	
	WaitTimer( Timer )
	Flip( 0 )
	
Wend




Function InitProgram()
	
	MenuChoice = 1
	KeyList = CreateList()
	ParticleList = CreateList()
	
	Local I:Int
	Local HighScoreFileStream:TStream = ReadFile( "highscore" )
	If HighScoreFileStream Then
		For I = 0 To 3
			Highscores[I] = ReadInt(HighScoreFileStream)
		Next
	End If
	
	Image_Status = CreateImage(448,64)
	SetColor 112,112,112
	DrawRect 0,0,448,64
	SetColor 80,80,80
	Local X:Int, Y:Int
	For X = -1 To 28
		For Y = -1 To 4
			If (X+Y*27) Mod 2 = 0 Then DrawRect X*16-8,Y*16-6,16,16
		Next
	Next
	GrabImage( Image_Status,0,0 )
	
	ReadWords( "words\easy.txt", 0 )
	ReadWords( "words\medium.txt", 1 )
	ReadWords( "words\hard.txt", 2 )
	
End Function

Function ReadWords( File:String, Index:Int )
	
	Local I:Int
	Local WordsStream:TStream = ReadFile( File )
	Local CountWords:Int = Int( ReadLine( WordsStream ) )
	Words[Index] = New String[ CountWords ]
	For I = 1 To CountWords
		Words[Index][I-1] = ReadLine( WordsStream )
	Next
	
End Function

Function InitGame()
	
	Counter = 0
	Lifes = 5
	TKey.Speed = 1.9
	SeedRnd MilliSecs()
	KeyList = CreateList()
	ParticleList = CreateList()
	CreationInterval = 90
	FlushKeys()
	If GameMode = 2 Then
		KeyStack = New String[3+Difficulty*2]
	End If
	
End Function

Function Update()
	
	If Paused = False Then
		
		Local Particle:TParticle
		
		Local I:Int
		
		Local Key:TKey
		For Key = EachIn KeyList
			Key.Update()
			If Key.Del = True Then
				For I = 0 To 15
					Particle = New TParticle
					ParticleList.AddLast( Particle )
					Particle.Init( Key.X, Key.Y, 8, I )
				Next
				ListRemove( KeyList, Key )
				Key = Null
			End If
		Next
		
		For Particle = EachIn ParticleList
			Particle.Update()
			If Particle.Del = True Then
				ListRemove( ParticleList, Particle )
				Particle = Null
			End If
		Next
		
		If Lifes <= 0 Then GameOver()
		
		CreationCounter :+ 1
		
		If CreationCounter >= CreationInterval Then
			Select GameMode
				Case 1
					Key = New TKey
					KeyList.AddLast( Key )
					Local ToDestroy:Int = DistProbability( [0,1], [0.3,0.7] )
					Key.Init( Chr( Rand( Asc("A"), Asc("Z") ) ), ToDestroy, ToDestroy )
					CreationCounter :- CreationInterval
				Case 2
					If KeyStack[0] = "" Then
						Local L:Int = 11 - Difficulty*2
						KeyStack = New String[L]
						Local Index:Int = Rand(0,Words[Difficulty-1].Length-1)
						CurrentWord  = Words[Difficulty-1][Index]
						For I = 0 To (L-1)
							KeyStack[I] = Chr(CurrentWord[I])
						Next
					End If
					
					Local Char:String
					Local ToDestroy:Int = DistProbability( [0,1], [0.4,0.6] )
					If ToDestroy = 0 Then
						Char = KeyStack[0]
						If KeyStack.Length > 1 Then
							KeyStack = KeyStack[1..]
						Else
							KeyStack[0] = ""
						End If
					Else
						Local OK:Int = False
						While OK = False
							Char = Chr( Rand( Asc("A"), Asc("Z") ) )
							If Instr( CurrentWord, Char ) = False Then OK = True
						Wend
					End If
					
					Key = New TKey
					KeyList.AddLast( Key )
					Key.Init( Char, ToDestroy, TKey.COLOR_GREEN )
					
					CreationCounter :- CreationInterval
			End Select
		End If
		
		Select Counter
			Case 10,25,45,70,100,135,175,220
				If TKey.SpeedIncreased = 0 Then
					If Not( GameMode = 2 And Counter >= 175 ) Then
						TKey.Speed :+ TKey.SpeedIncrease
						CreationInterval :- CreationIntervalDecrease
						TKey.SpeedIncreased = 1
						FasterTextTime = 90
					End If
				End If
				
			Default
				TKey.SpeedIncreased = 0
		End Select
		
	Else
		
		ChangeBGColor()
		
	End If
	
	If KeyHit( KEY_SPACE ) Then
		Paused = Not( Paused )
		FlushKeys()
	End If
	
End Function

Function Render()
	
	SetColor BGColor_R, BGColor_G, BGColor_B
	DrawImage Image_Background, 0, 0
	SetColor 255,255,255
	
	If Paused = False Then
		Local Key:TKey
		For Key = EachIn KeyList
			Key.Render()
		Next
		
		If ShowParticles = True Then
			Local Particle:TParticle
			For Particle = EachIn ParticleList
				Particle.Render()
			Next
		End If
	Else
		SetColor 255-BGColor_R, 255-BGColor_G, 255-BGColor_B
		SetScale 5,5
		DrawCenteredText( "Pause", 224, 50, 5 )
		SetScale 1,1
		SetColor 255,255,255
	End If
	
	If FasterTextTime > 0 Then
		SetColor 255-BGColor_R, 255-BGColor_G, 255-BGColor_B
		SetScale 3,3
		DrawCenteredText( "Schneller!", 224, 50, 3 )
		FasterTextTime :- 1
		SetScale 1,1
	End If
	
	SetColor 255,255,255
	DrawImage Image_Status, 0, 516
	
	Local I:Int
	For I = 0 To Lifes-1
		DrawImage Image_Heart, 4+32*I, 544
	Next
	
	If GameMode = 2 And Difficulty > 0 Then
		SetScale 3,3
		DrawText CurrentWord, 200, 548-TextHeight(CurrentWord)*3/2
		SetScale 1,1
	End If
	
	If Counter > 0 Or (GameMode = 1) Or (GameMode = 2 And Difficulty > 0) Then
		DrawText "Punkte: " + Counter, 7, 525
	End If
	
End Function

Function Menu()
	
	SetColor 10,10,10
	SetAlpha .5
	DrawRect 50, 190, 348, 200
	SetColor 255,255,255
	SetAlpha 1
	
	If MenuChoice < 1 Then MenuChoice = 3
	If MenuChoice > 3 Then MenuChoice = 1
	
	If GameMode = 0 Then
		DrawCenteredText( "Waehlen Sie einen Modus!", 224, 210 )
		DrawCenteredText( "Normaler Modus", 224, 245 )
		DrawCenteredText( "~qWords~q", 224, 275 )
		DrawCenteredText( "Beenden", 224, 305 )
		DrawCenteredText( ">                  <", 224, 215+MenuChoice*30 )
		If MenuChoice = 1 Then
			DrawCenteredText( "Druecken Sie die roten Tasten!", 224, 350 )
			DrawCenteredText( "Highscore: " + Highscores[0], 224, 370 )
		End If
		If MenuChoice = 2 Then
			DrawCenteredText( "Druecken Sie die Buchstaben, ", 224, 350 )
			DrawCenteredText( "die nicht im gegebenen Wort vorkommen." ), 224, 370
		End If
		If KeyHit( KEY_ENTER ) Then GameMode = MenuChoice
		If GameMode = 1 Then InitGame()
		If GameMode = 3 Then Terminate = True
		If KeyHit( KEY_ESCAPE ) Then Terminate = True
	ElseIf GameMode = 2
		DrawCenteredText( "Waehlen Sie einen Schwierigkeitsgrad!", 224, 210 )
		DrawCenteredText( "Einfach", 224, 245 )
		DrawCenteredText( "Mittel", 224, 275 )
		DrawCenteredText( "Schwierig", 224, 305 )
		DrawCenteredText( ">                  <", 224, 215+MenuChoice*30 )
		If MenuChoice = 1 Then DrawCenteredText( "Wortlaenge: 9, wenige Wechsel", 224, 350 )
		If MenuChoice = 2 Then DrawCenteredText( "Wortlaenge: 7", 224, 350 )
		If MenuChoice = 3 Then DrawCenteredText( "Wortlaenge: 5, viele Wechsel", 224, 350 )
		DrawCenteredText( "Highscore: " + Highscores[MenuChoice], 224, 370 )
		If KeyHit( KEY_ENTER ) Then Difficulty = MenuChoice
		If Difficulty <> 0 Then InitGame()
		If KeyHit( KEY_ESCAPE ) Then GameMode = 0
	End If
	
	If KeyHit( KEY_UP ) Then MenuChoice :- 1
	If KeyHit( KEY_DOWN ) Then MenuChoice :+ 1
	
	ChangeBGColor()
	
End Function

Function ChangeBGColor()
	If KeyHit(KEY_R) Then BGColor_RM = Not(BGColor_RM)*(2*((BGColor_R<=0)*2-1))
	If KeyHit(KEY_G) Then BGColor_GM = Not(BGColor_GM)*(2*((BGColor_G<=0)*2-1))
	If KeyHit(KEY_B) Then BGColor_BM = Not(BGColor_BM)*(2*((BGColor_B<=0)*2-1))
	
	BGColor_R :+ BGColor_RM
	BGColor_G :+ BGColor_GM
	BGColor_B :+ BGColor_BM
	
	If BGColor_R<=0 Or BGColor_R>=255 Then BGColor_RM = 0
	If BGColor_G<=0 Or BGColor_G>=255 Then BGColor_GM = 0
	If BGColor_B<=0 Or BGColor_B>=255 Then BGColor_BM = 0
End Function

Function GameOver()
	
	Local HighScoresIndex:Int = GameMode+(Difficulty-1)*(GameMode-1)-1
	If Counter > Highscores[HighScoresIndex] Then
		Highscores[HighScoresIndex] = Counter
		Local HighScoreFileStream:TStream = WriteFile( "highscore" )
		If HighScoreFileStream Then
			Local I:Int
			For I = 0 To 3
				WriteInt(HighScoreFileStream, Highscores[I])
			Next
		End If
	End If
	
	GameMode = 0
	Difficulty = 0
	Paused = 0
	Lifes = 0
	
End Function

Function DrawCenteredText( Text:String, X:Int, Y:Int, Scale:Int = 1 )
	
	DrawText Text, X-TextWidth(Text)*Scale/2, Y-TextHeight(Text)*Scale/2
	
End Function

Function DistProbability:Int( Values:Int[], Probs:Float[] )
	
	Local RandomFloat:Float = Rnd(0,1)
	
	Local I:Int
	For I = 1 To Values.Length
		If RandomFloat <= Probs[I-1] Then
			Return Values[I-1]
		Else
			RandomFloat :- Probs[I-1]
		End If
	Next
	
End Function
